'Diamonds puzzle game for Maximite
'MM Basic v3.1 , Game v1.0

Option Base 1

MapFile$ = "lvl_001.lvl"
Sprite_W = 32
Sprite_H = 32
NbSprite = 80
First = 41
Last = 120
Dim Map_Level(15, 12)
Level_W = 15
Level_H = 12
'Specific variables for the game
NbMonsters = 0
NbDiam = 0
NbRocks = 0
Score = 0
Lives = 3
Level_Number = 1
MaxLevel = 5
Dim DoorCase(2)
ActKey = 0
'Maximum 50 rocks , 50 diamonds and 20 monsters per level !!
Dim Rocks(50, 13)
Dim Diams(50, 13)
Dim Hero(9)
Dim Monsters(20, 9)
' Diamonds Pictures Number
MaxDiamPic = 4
Dim DiamPic(MaxDiamPic)
' Rocks Pictures Number
MaxRocksPic = 4
Dim RocksPic(MaxRocksPic)
' Dynamite Pictures number
MaxDynamPic = 8
Dim DynamPic(MaxDynamPic)
' Explosion Pictures number
MaxExploPic = 8
Dim ExploPic(MaxExploPic)
' Wall Picture number
MaxWallPic = 2
Dim WallPic(MaxWallPic)
' Door Pictures number
MaxDoorPic = 8
Dim DoorPic(MaxDoorPic)
' Hero Pictures number
MaxDirectionPic = 4
Dim Hero_go_down(MaxDirectionPic)
Dim Hero_go_up(MaxDirectionPic)
Dim Hero_go_left(MaxDirectionPic)
Dim Hero_go_right(MaxDirectionPic)
Dim Hero_push_right(MaxDirectionPic)
Dim Hero_push_left(MaxDirectionPic)
' Define the picture when Hero dont move for at least 2sec
Hero_dont_move = 41
BlankCase = 110
HeroCase = 253
Game_Timer = 200
RD_Timer = 50
' ***** Main part of the game *****
Font Load "Diam.fnt" As #6
Font #6
' Joystick PIN's definition
'PIN 11 = UP
SetPin 11,2
'PIN 12 = DOWN
SetPin 12,2
'PIN 13 = LEFT
SetPin 13,2
'PIN 14 = RIGHT
SetPin 14,2
'PIN 15 = Button 1
SetPin 15,2
'PIN 16 = Button 2
SetPin 16,2
Cls
Init_Sprites
Read_Map_File (MapFile$)
Show_Map
Init_Rocks
Init_Diamonds
Init_Hero
' ***** Main game loop *****
Timer = 0
Cnt_RD = 0
Do While 1
 If Timer >= Game_Timer Then
  Timer = 0
  Game_Timer_State
 EndIf
 If Cnt_RD >= RD_Timer Then
  Check_Rocks
  Check_Diamonds
  Cnt_RD = 0
 EndIf
 Cnt_RD = Cnt_RD + 1
 Font #1
 Print @(10,400) "                      "
 Print @(10,400) Cnt_RD , Timer
 Font #6
Loop
' ***** Sub Programs *****

Sub Game_Timer_State
 Local kb$
 '&h80 : UP , &h81 : DOWN , &h83 : RIGHT, &h82 : LEFT
 kb$ = Inkey$
 If (Asc(kb$) >= &h80) And (Asc(kb$) <= &h83) Then
  ActKey = Asc(kb$)
 EndIf
 If Pin(11) = 0 Then ActKey = &h80
 If Pin(12) = 0 Then ActKey = &h81
 If Pin(13) = 0 Then ActKey = &h82
 If Pin(14) = 0 Then ActKey = &h83
 If ActKey = &h80 Then Hero_Move 1
 If ActKey = &h83 Then Hero_Move 2
 If ActKey = &h81 Then Hero_Move 3
 If ActKey = &h82 Then Hero_Move 4
 ActKey = 0
End Sub

Sub Init_Sprites
 Local i
 'Initialise all sprites numbers
 For i = 1 To 4
  DiamPic(i) = i + 68
  RocksPic(i) = i + 64
  Hero_go_down(i) = i + 40
  Hero_go_up(i) = i + 44
  Hero_go_left(i) = i + 48
  Hero_go_right(i) = i + 52
  Hero_push_right(i) = i + 56
  Hero_push_left(i) = i + 60
 Next i
 For i = 1 To 8
  DynamPic(i) = i + 80
  ExploPic(i) = i + 88
  DoorPic(i) = i + 96
 Next i
 WallPic(1) = 105
 WallPic(2) = 105
 Hero(3) = 41
End Sub

Sub Read_Map_File(Map_File$)
 ' Here we read the Map file
 Local CntX, CntY
 Local Starting, Stoping
 Local Tmp$
 Local LineRead$
 'Before we read a map we reset some game variables
 NbMonsters = 0
 NbDiam = 0
 NbRocks = 0
 'And we read the map
 Open Map_File$ For Input As #1
  For CntY = 1 To Level_H
   Line Input #1, LineRead$
   Starting = 1
   For CntX = 1 To Level_W
    ' Decode each line from the map
    Stoping = Instr(Starting, LineRead$, ":")
    Tmp$ = Mid$(LineRead$, Starting, Stoping - Starting)
    Map_Level(CntX, CntY) = Val(Tmp$) + 40
    Starting = Stoping + 1
   Next CntX
  Next CntY
 Close #1
 'Get the map elements
 Get_Map_Elements
End Sub

Sub Get_Map_Elements
 ' Here we get the monsters , door , diamonds position
 Local CntX, CntY
 For CntY = 1 To Level_H
  For CntX = 1 To Level_W
   'Hero position
   If (Map_Level(CntX, CntY) >= 41) And (Map_Level(CntX, CntY) <= 64) Then
    Hero(1) = CntX
    Hero(2) = CntY
   EndIf
   'Rocks position
   If (Map_Level(CntX, CntY) >= 65) And (Map_Level(CntX, CntY) <= 68) Then
    NbRocks = NbRocks + 1
    Rocks(NbRocks, 1) = CntX
    Rocks(NbRocks, 2) = CntY
    Rocks(NbRocks, 3) = Map_Level(CntX, CntY)
   EndIf
   'Diamonds position
   If (Map_Level(CntX, CntY) >= 69) And (Map_Level(CntX, CntY) <= 72) Then
    NbDiam = NbDiam + 1
    Diams(NbDiam, 1) = CntX
    Diams(NbDiam, 2) = CntY
    Diams(NbDiam, 3) = Map_Level(CntX, CntY)
   EndIf
   'Monsters position
   If (Map_Level(CntX, CntY) >= 73) And (Map_Level(CntX, CntY) <= 80) Then
    NbMonsters = NbMonsters + 1
    Monsters(NbMonsters, 1) = CntX
    Monsters(NbMonsters, 2) = CntY
    Monsters(NbMonsters, 3) = Map_Level(CntX, CntY)
   EndIf
   'Exit Door position
   If (Map_Level(CntX, CntY) >= 97) And (Map_Level(CntX, CntY) <= 104) Then
    DoorCase(1) = CntX
    DoorCase(2) = CntY
   EndIf
   'Empty position
   If (Map_Level(CntX, CntY) >= 110) Then
    Map_Level(CntX, CntY) = BlankCase
   EndIf
  Next CntX
 Next CntY
End Sub

Sub Check_Rocks
 ' Check if a Rock can fall down or if he kill the Hero
 Local i
 'Rescan the rocks
 Rescan_Rocks
 For i = 1 To NbRocks
  'Reset Rock direction
  Rocks(i, 4) = 0
  'Test for fall down
  If (Rocks(i, 10) = BlankCase) Then
   Rocks(i, 4) = 1
  EndIf
  'Test for fall left down
  If ((Rocks(i, 4) <> 1) And (Rocks(i, 12) = BlankCase) And (Rocks(i, 11) = BlankCase) And (Rocks(i, 10) > 65) And (Rocks(i, 10) < 72) And (Rocks(i, 10) <> HeroCase)) Then
   Rocks(i, 4) = 2
  EndIf
  'Test for fall right down
  If ((Rocks(i, 4) <> 1) And (Rocks(i, 8) = BlankCase) And (Rocks(i, 9) = BlankCase) And (Rocks(i, 10) > 65) And (Rocks(i, 10) < 72) And (Rocks(i, 10) <> HeroCase)) Then
   Rocks(i, 4) = 3
  EndIf
  'Draw the rock to new position if needed
  If Rocks(i, 4) <> 0 Then
   Print @((Rocks(i, 1) - 1) * Sprite_W, (Rocks(i, 2) - 1) * Sprite_H) Chr$(BlankCase)
   Map_Level(Rocks(i, 1), Rocks(i, 2)) = BlankCase
   If (Rocks(i, 4) = 1) Then
    Rocks(i, 2) = Rocks(i, 2) + 1
   EndIf
   If (Rocks(i, 4) = 2) Then
    Rocks(i, 1) = Rocks(i, 1) - 1
    Rocks(i, 2) = Rocks(i, 2) + 1
   EndIf
   If (Rocks(i, 4) = 3) Then
    Rocks(i, 1) = Rocks(i, 1) + 1
    Rocks(i, 2) = Rocks(i, 2) + 1
   EndIf
   'Set the new Rock picture
   If ((Rocks(i, 3) + 1) > RocksPic(MaxRocksPic)) Then
     Rocks(i, 3) = RocksPic(1)
   Else
     Rocks(i, 3) = Rocks(i, 3) + 1
   EndIf
   'Redraw the Rock to the new position
   Print @((Rocks(i, 1) - 1) * Sprite_W, (Rocks(i, 2) - 1) * Sprite_H) Chr$(Rocks(i, 3))
   Map_Level(Rocks(i, 1), Rocks(i, 2)) = Rocks(i, 3)
   Rescan_Rocks
  EndIf
 Next i
End Sub

Sub Rescan_Rocks
 ' Check arround each Rocks after a Rock moving
 Local i
 For i = 1 To NbRocks
  Rocks(i, 6) = Map_Level(Rocks(i, 1), Rocks(i, 2) - 1)
  Rocks(i, 7) = Map_Level(Rocks(i, 1) + 1, Rocks(i, 2) - 1)
  Rocks(i, 8) = Map_Level(Rocks(i, 1) + 1, Rocks(i, 2))
  Rocks(i, 9) = Map_Level(Rocks(i, 1) + 1, Rocks(i, 2) + 1)
  Rocks(i, 10) = Map_Level(Rocks(i, 1), Rocks(i, 2) + 1)
  Rocks(i, 11) = Map_Level(Rocks(i, 1) - 1, Rocks(i, 2) + 1)
  Rocks(i, 12) = Map_Level(Rocks(i, 1) - 1, Rocks(i, 2))
  Rocks(i, 13) = Map_Level(Rocks(i, 1) - 1, Rocks(i, 2) - 1)
 Next i
End Sub

Sub Check_Diamonds
 'Check if a Diamond can fall down
 Local i
 'Rescan the rocks
 Rescan_Diamonds
 For i = 1 To NbDiam
  'Reset Rock direction
  Diams(i, 4) = 0
  'Test for fall down
  If (Diams(i, 10) = BlankCase) Then
   Diams(i, 4) = 1
  EndIf
  'Test for fall left down
  If ((Diams(i, 4) <> 1) And (Diams(i, 12) = BlankCase) And (Diams(i, 11) = BlankCase) And (Diams(i, 10) >= 65) And (Diams(i, 10) <= 72) And (Diams(i, 10) <> HeroCase)) Then
   Diams(i, 4) = 2
  EndIf
  'Test for fall right down
  If ((Diams(i, 4) <> 1) And (Diams(i, 8) = BlankCase) And (Diams(i, 9) = BlankCase) And (Diams(i, 10) >= 65) And (Diams(i, 10) <= 72) And (Diams(i, 10) <> HeroCase)) Then
   Diams(i, 4) = 3
  EndIf
  'Draw the rock to new position if needed
  If Diams(i, 4) <> 0 Then
   Print @((Diams(i, 1) - 1) * Sprite_W, (Diams(i, 2) - 1) * Sprite_H) Chr$(BlankCase)
   Map_Level(Diams(i, 1), Diams(i, 2)) = BlankCase
   If (Diams(i, 4) = 1) Then
    Diams(i, 2) = Diams(i, 2) + 1
   EndIf
   If (Diams(i, 4) = 2) Then
    Diams(i, 1) = Diams(i, 1) - 1
    Diams(i, 2) = Diams(i, 2) + 1
   EndIf
   If (Diams(i, 4) = 3) Then
    Diams(i, 1) = Diams(i, 1) + 1
    Diams(i, 2) = Diams(i, 2) + 1
   EndIf
   'Set the new Diamond picture
   If ((Diams(i, 3) + 1) > DiamPic(MaxDiamPic)) Then
    Diams(i, 3) = DiamPic(1)
   Else
    Diams(i, 3) = Diams(i, 3) + 1
   EndIf
   'Redraw the Diamonds to the new position
   Print @((Diams(i, 1) - 1) * Sprite_W, (Diams(i, 2) - 1) * Sprite_H) Chr$(Diams(i, 3))
   Map_Level(Diams(i, 1), Diams(i, 2)) = Diams(i, 3)
   Rescan_Diamonds
  EndIf
 Next i
End Sub

Sub Rescan_Diamonds
 ' Check arround each Diamonds after a Diamond moving
 Local i
 For i = 1 To NbDiam
  Diams(i, 6) = Map_Level(Diams(i, 1), Diams(i, 2) - 1)
  Diams(i, 7) = Map_Level(Diams(i, 1) + 1, Diams(i, 2) - 1)
  Diams(i, 8) = Map_Level(Diams(i, 1) + 1, Diams(i, 2))
  Diams(i, 9) = Map_Level(Diams(i, 1) + 1, Diams(i, 2) + 1)
  Diams(i, 10) = Map_Level(Diams(i, 1), Diams(i, 2) + 1)
  Diams(i, 11) = Map_Level(Diams(i, 1) - 1, Diams(i, 2) + 1)
  Diams(i, 12) = Map_Level(Diams(i, 1) - 1, Diams(i, 2))
  Diams(i, 13) = Map_Level(Diams(i, 1) - 1, Diams(i, 2) - 1)
 Next i
End Sub

Sub Init_Rocks
 ' Initialise the Rocks status at start from level
 Dim i, j, k
 NbRocks = 0
 For i = 1 To Level_W
  For j = 1 To Level_H
  'we test if we have a rock here
   If (Map_Level(i, j) >= RocksPic(1)) And (Map_Level(i, j) <= RocksPic(MaxRocksPic)) Then
    NbRocks = NbRocks + 1
    Rocks(NbRocks, 1) = i
    Rocks(NbRocks, 2) = j
    Rocks(NbRocks, 3) = Map_Level(i, j)
    Rocks(NbRocks, 4) = 0
    Rocks(NbRocks, 5) = 0
    Rocks(NbRocks, 6) = Map_Level(i, j - 1)
    Rocks(NbRocks, 7) = Map_Level(i + 1, j - 1)
    Rocks(NbRocks, 8) = Map_Level(i + 1, j)
    Rocks(NbRocks, 9) = Map_Level(i + 1, j + 1)
    Rocks(NbRocks, 10) = Map_Level(i, j + 1)
    Rocks(NbRocks, 11) = Map_Level(i - 1, j + 1)
    Rocks(NbRocks, 12) = Map_Level(i - 1, j)
    Rocks(NbRocks, 13) = Map_Level(i - 1, j - 1)
   EndIf
  Next j
 Next i
End Sub

Sub Init_Diamonds
 'Initialise the Diamonds status at start from level
 Local i, j, k
 NbDiam = 0
 For i = 1 To Level_W
  For j = 1 To Level_H
  'we test if we have a rock here
   If (Map_Level(i, j) >= DiamPic(1)) And (Map_Level(i, j) <= DiamPic(MaxDiamPic)) Then
    NbDiam = NbDiam + 1
    Diams(NbDiam, 1) = i
    Diams(NbDiam, 2) = j
    Diams(NbDiam, 3) = Map_Level(i, j)
    Diams(NbDiam, 4) = 0
    Diams(NbDiam, 5) = 0
    Diams(NbDiam, 6) = Map_Level(i, j - 1)
    Diams(NbDiam, 7) = Map_Level(i + 1, j - 1)
    Diams(NbDiam, 8) = Map_Level(i + 1, j)
    Diams(NbDiam, 9) = Map_Level(i + 1, j + 1)
    Diams(NbDiam, 10) = Map_Level(i, j + 1)
    Diams(NbDiam, 11) = Map_Level(i - 1, j + 1)
    Diams(NbDiam, 12) = Map_Level(i - 1, j)
    Diams(NbDiam, 13) = Map_Level(i - 1, j - 1)
   EndIf
  Next j
 Next i
End Sub

Sub Init_Hero
 'Initialise the Hero status at start from level
 Local i, j, k
 For i = 1 To Level_W
  For j = 1 To Level_H
   'we test if we found the Hero here
   If Map_Level(i, j) = HeroCase Then
    'We got the Hero
    Hero(1) = i
    Hero(2) = j
    Hero(3) = Hero_dont_move
    Hero(4) = 5
    Hero(6) = Map_Level(i, j - 1)
    Hero(7) = Map_Level(i + 1, j)
    Hero(8) = Map_Level(i, j + 1)
    Hero(9) = Map_Level(i - 1, j)
   EndIf
  Next j
 Next i
End Sub

Sub Hero_Move(newd)
 ' Move the Hero and look for collision with
 ' wall , Rocks , etc ....
 Local i
 Local foundrock
 Local foundwall
 Local oldx, oldy, oldd
 Local newx, newy
 oldx = Hero(1)
 oldy = Hero(2)
 oldd = Hero(4)
 foundrock = 0
 foundwall = 0
 'up
 If newd = 1 Then
  newx = Hero(1)
  newy = Hero(2) - 1
 EndIf
 'right
 If newd = 2 Then
  newx = Hero(1) + 1
  newy = Hero(2)
 EndIf
 'down
 If newd = 3 Then
  newx = Hero(1)
  newy = Hero(2) + 1
 EndIf
 'left
 If newd = 4 Then
  newx = Hero(1) - 1
  newy = Hero(2)
 EndIf
 ' check for Rocks
 For i = 1 To NbRocks
  If ((Rocks(i, 1) = newx) And (Rocks(i, 2) = newy)) Then foundrock = i
 Next i
 'If a rock is found , check if we can puch it away
 If foundrock <> 0 Then
  Rescan_Rocks
  If (newd = 2) And (Rocks(foundrock, 8) = BlankCase) Then
   Print @((Rocks(foundrock, 1) - 1) * Sprite_W, (Rocks(foundrock, 2) - 1) * Sprite_H) Chr$(BlankCase)
   Rocks(foundrock, 1) = Rocks(foundrock, 1) + 1
   Print @((Rocks(foundrock, 1) - 1) * Sprite_W, (Rocks(foundrock, 2) - 1) * Sprite_H) Chr$(Rocks(foundrock, 3))
   foundrock = 0
  EndIf
  If foundrock <> 0 Then
   If (newd = 4) And (Rocks(foundrock, 12) = BlankCase) Then
    Print @((Rocks(foundrock, 1) - 1) * Sprite_W, (Rocks(foundrock, 2) - 1) * Sprite_H) Chr$(BlankCase)
    Rocks(foundrock, 1) = Rocks(foundrock, 1) - 1
    Print @((Rocks(foundrock, 1) - 1) * Sprite_W, (Rocks(foundrock, 2) - 1) * Sprite_H) Chr$(Rocks(foundrock, 3))
   EndIf
  EndIf
 EndIf
 'check for wall & Rock
 If ((Map_Level(newx, newy) >= WallPic(1)) And (Map_Level(newx, newy) <= WallPic(MaxWallPic))) Then
  foundwall = 1
 EndIf
 'check if we can move
 If ((foundrock = 0) And (foundwall = 0)) Then
  Hero(1) = newx
  Hero(2) = newy
  Hero(4) = newd
  'We have to choose the right Hero Sprite
  If Hero(4) = oldd Then
   If newd = 1 Then
    If (Hero(3) + 1) > Hero_go_up(MaxDirectionPic) Then
     Hero(3) = Hero_go_up(1)
    Else
     Hero(3) = Hero(3) + 1
    EndIf
   EndIf
   If newd = 2 Then
    If (Hero(3) + 1) > Hero_go_right(MaxDirectionPic) Then
     Hero(3) = Hero_go_right(1)
    EndIf
   Else
    Hero(3) = Hero(3) + 1
   EndIf
   If newd = 3 Then
    If (Hero(3) + 1) > Hero_go_down(MaxDirectionPic) Then
     Hero(3) = Hero_go_down(1)
    EndIf
   Else
    Hero(3) = Hero(3) + 1
   EndIf
   If newd = 4 Then
    If (Hero(3) + 1) > Hero_go_left(MaxDirectionPic) Then
     Hero(3) = Hero_go_left(1)
    EndIf
   Else
    Hero(3) = Hero(3) + 1
   EndIf
  Else
   If newd = 1 Then
    Hero(3) = Hero_go_up(1)
   EndIf
   If newd = 2 Then
    Hero(3) = Hero_go_right(1)
   EndIf
   If newd = 3 Then
    Hero(3) = Hero_go_down(1)
   EndIf
   If newd = 4 Then
    Hero(3) = Hero_go_left(1)
   EndIf
  EndIf
 EndIf
 ' Delete the actual Hero position
 Print @((oldx - 1) * Sprite_W, (oldy - 1) * Sprite_H) Chr$(BlankCase)
 ' Draw the Hero at new position
 Print @((Hero(1) - 1) * Sprite_W, (Hero(2) - 1) * Sprite_H) Chr$(Hero(3))
 Map_Level(oldx, oldy) = BlankCase
 Map_Level(Hero(1), Hero(2)) = HeroCase
 Init_Diamonds
 If NbDiam = 0 Then
  Level_Number = Level_Number + 1
  If Number >= 100 Then MapFile$ = "lvl_" + Str$(Level_Number) + ".lvl"
  If Number < 100 Then MapFile$ = "lvl_0" + Str$(Level_Number) + ".lvl"
  If Number < 10 Then MapFile$ = "lvl_00" + Str$(Level_Number) + ".lvl"
  If (Level_Number <= MaxLevel) Then
   Read_Map_File MapFile$
   Show_Map
   Init_Rocks
   Init_Diamonds
   Init_Hero
  Else
   Level_Number = 1
   MapFile$ = "lvl_001.lvl"
   Read_Map_File MapFile$
   Show_Map
   Init_Rocks
   Init_Diamonds
   Init_Hero
  EndIf
 EndIf
End Sub

Sub Show_Map
 'Show the loaded map
 Local CntX, CntY
 For CntY = 1 To Level_H
  For CntX = 1 To Level_W
   If (Map_Level(CntX, CntY) > 64) And (Map_Level(CntX, CntY) < 110) Then
    Print @((CntX - 1) * Sprite_W, (CntY - 1) * Sprite_H) Chr$(Map_Level(CntX, CntY))
   Else
    If Map_Level(CntX, CntY) >= 110 Then
     Map_Level(CntX, CntY) = BlankCase
     Print @((CntX - 1) * Sprite_W, (CntY - 1) * Sprite_H) Chr$(Map_Level(CntX, CntY))
    EndIf
    If Map_Level(CntX, CntY) <= 64 Then
     Map_Level(CntX, CntY) = HeroCase
     Hero(3) = 41
     Print @((CntX - 1) * Sprite_W, (CntY - 1) * Sprite_H) Chr$(Hero(3))
    EndIf
   EndIf
  Next CntX
 Next CntY
End Sub
